/*	immanager - Text Input Method Manager
 *
 *  gtkimcontextptim.h - 
 *
 *	Authors: YE Nan <nan.ye@orange-ftgourp.com>,
 *           LUO Lei <Srella@163.com>
 *
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __GTK_IM_CONTEXT_PTIM_H
#define __GTK_IM_CONTEXT_PTIM_H

#include <gtk/gtk.h>
#include <gmodule.h>

#include <standard_im.h>
#include "ptimhelpermodule.h"
#include "ptimenginemodule.h"

G_END_DECLS
extern GType im_context_ptim_type;

#define GTK_TYPE_IM_CONTEXT_PTIM						(im_context_ptim_type)
#define GTK_IM_CONTEXT_PTIM_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), GTK_TYPE_IM_CONTEXT_PTIM, GtkIMContextPTIMClass))
#define GTK_IM_CONTEXT_PTIM(object)					(G_TYPE_CHECK_INSTANCE_CAST((object), GTK_TYPE_IM_CONTEXT_PTIM, GtkIMContextPTIM))
#define IS_GTK_IM_CONTEXT_PTIM_CLASS(klass)		(G_TYPE_CHECK_CLASS_TYPE((klass), GTK_TYPE_IM_CONTEXT_PTIM))
#define IS_GTK_IM_CONTEXT_PTIM(object)						(G_TYPE_CHECK_INSTANCE_TYPE((object), GTK_TYPE_IM_CONTEXT_PTIM))
#define GTK_IM_CONTEXT_PTIM_GET_CLASS(object)	(G_TYPE_INSTANCE_GET_CLASS((object), GTK_TYPE_IM_CONTEXT_PTIM, GtkIMContextPTIMClass))

typedef struct _GtkIMContextPTIM				GtkIMContextPTIM;
typedef struct _GtkIMContextPTIMClass	GtkIMContextPTIMClass;

struct _GtkIMContextPTIM {
	/* Super place holder. */
	GtkIMContext super;

	GdkWindow							*client_window;

	PtimEngineModule		*engine_module;
	PtimHelperModule		*helper_module;
	
	gchar									**engine_list;
	gchar									*helper_list[5];

	GArray							*ptim_engines_array;
	gint								 ptim_engines_count;
	gint								 ptim_engines_index;

	GArray							*ptim_helpers_array;
	gint								 ptim_helpers_count;
	gint								 ptim_helpers_index;

	IME_InputContext		*input_context;
	IME_CandidatesList	*preedit_candidates_list;
	IME_CandidatesList	*candidates_list;
	IME_Status						 status;

	gboolean							 numeric_select;
};

struct _GtkIMContextPTIMClass {
	GtkIMContextClass super_class;
};

GType						gtk_im_context_ptim_get_type				(void) G_GNUC_CONST;
void							gtk_im_context_ptim_register_type	(GTypeModule * type_module);
GtkIMContext *	gtk_im_context_ptim_new							(void);

G_END_DECLS

#endif /* __GTK_IM_CONTEXT_PTIM_H */
