/*	immanager - Text Input Method Manager
 *
 *  ptimenginemodule.h - 
 *
 *	Authors: YE Nan <nan.ye@orange-ftgourp.com>,
 *           LUO Lei <Srella@163.com>
 *
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __PTIM_ENGINE_MODULE_H
#define __PTIM_ENGINE_MODULE_H

#include <standard_im.h>

extern GType ptim_engine_module_type;

#define	PTIM_TYPE_ENGINE_MODULE								(ptim_engine_module_type)
#define	PTIM_ENGINE_MODULE(obj)								(G_TYPE_CHECK_INSTANCE_CAST ((obj), PTIM_TYPE_ENGINE_MODULE, PtimEngineModule))
#define	PTIM_ENGINE_MODULE_CLASS(klass)			(G_TYPE_CHECK_CLASS_CAST ((klass), PTIM_TYPE_ENGINE_MODULE, PtimEngineModuleClass))
#define	PTIM_IS_PTIM_ENGINE_MODULE(obj)			(G_TYPE_CHECK_INSTANCE_TYPE ((obj), PTIM_TYPE_ENGINE_MODULE))
#define PTIM_IS_PTIM_ENGINE_MODULE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), PTIM_TYPE_ENGINE_MODULE))
#define PTIM_ENGINE_MODULE_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), PTIM_TYPE_ENGINE_MODULE, PtimEngineModuleClass))

typedef struct _PtimEngineModule				PtimEngineModule;
typedef struct _PtimEngineModuleClass	PtimEngineModuleClass;

struct _PtimEngineModule
{
  GTypeModule		 		parent_instance;

  GModule							*library;
  gchar								*path;

	gboolean						(*init) (GTypeModule	*type_module);
	gboolean						(*exit) (GTypeModule	*type_module);

  IMM_Functions			manager_func;
  IME_Functions			engine_func;
};

struct _PtimEngineModuleClass
{
	GTypeModuleClass	parent_class;
};

void ptim_engine_module_register_type (GTypeModule * type_module);

#endif /*__PTIM_ENGINE_MODULE_H*/

